/*-------------------------------------------------------------------------------------*/
/*              Nitrito v0.2 - render.c - Entre otras cosas renderiza                  */
/*                                                                                     */
/*                     Peazo de juego de coches 3d en opengl                           */
/*                                                                                     */
/*          Jou! Aqui empieza la accin. Hoy es: Sun Jan 27 17:28:23 2002              */
/*-------------------------------------------------------------------------------------*/

#include <allegro.h>
#include <alleggl.h>
#include <math.h>

#include "nitrito.h"
#include "render.h"
#include "mapas.h"
#include "carga_tex.h"
#include "fuentes.h"
#include "teclado.h"

int tamano_mapa = 50;


char textofs[50]= "Bienvenido al maravilloso mundo de Fixi Studios";


void inicializa_camara (void)
{
	camara.xangle=0;
	camara.yangle=0;
	camara.zangle=0;
	camara.dist_x=-67.5;
	camara.dist_y=1;
	camara.dist_z=-60;
};


void posiciona_camara (void)
{
	allegro_gl_begin();
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glFrustum (-0.01, 0.01, -0.01, 0.01, 0.01, 40.0);
	glTranslatef (0, 0, 0);
	glRotatef (camara.xangle, 1, 0, 0);
	glRotatef (camara.yangle, 0, 1, 0);
	glRotatef (camara.zangle, 0, 0, 1);
	glTranslatef (camara.dist_x, -camara.dist_y+0.5+cos(cabeza*3.14/180)*0.1, camara.dist_z);
	
	glMatrixMode (GL_MODELVIEW);
	allegro_gl_end();
}

void renderiza (void)
{
	int i,k/*,j,var*/,casilla, desfy;
	
	allegro_gl_begin();

    // Clear the RGB buffer and the depth buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // Set the modelview matrix to be the identity matrix
    glLoadIdentity();

    // Translate and rotate the object

	
	
	glEnable (GL_TEXTURE_2D);
	
	for(i=0;i<tamano_mapa;i++)
	{
		for(k=0;k<tamano_mapa;k++)
		{
			//if(abs(i*3+camara.dist_x)<40)
			//if(abs(k*3+camara.dist_z)<40)
			if((camara.yangle>-10 && camara.yangle<=180 && i*3+camara.dist_x<35 && i*3+camara.dist_x>-25)
				|| (camara.yangle>180 && camara.yangle<400 && i*3+camara.dist_x>-35 && i*3+camara.dist_x<25)) 
			if(( ((camara.yangle>270 || camara.yangle<=90)) && k*3+camara.dist_z>-35 && k*3+camara.dist_z<25)
				|| (camara.yangle>90 && camara.yangle<=270 && k*3+camara.dist_z<35 && k*3+camara.dist_z>-25)) 
			{
				glTranslatef (0, 0, 0);
				desfy=0;
				casilla=mapa[k][i];
				if(casilla>=200 && casilla<400)
				{
					desfy=1;
					glTranslatef (0, desfy, 0);
					casilla-=200;
				}
				if(casilla>=400 && casilla<600)
				{
					desfy=2;
					glTranslatef (0, desfy, 0);
					casilla-=400;
				}
				if(casilla>=600 && casilla<800)
				{
					desfy=3;
					glTranslatef (0, desfy, 0);
					casilla-=600;
				}
				if(casilla>=800 && casilla<1000)
				{
					desfy=4;
					glTranslatef (0, desfy, 0);
					casilla-=800;
				}
				
				if(casilla>=0 && casilla<100) //suelo normal
				{
					glBindTexture (GL_TEXTURE_2D, textura[casilla]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==100) //hierba con letrero
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					
					glEnable (GL_BLEND);
					if(frame>17) allegro_gl_printf(allegro_fnt[1], i*3-20, 8.7-(float)frame/10, k*3-3.5, 0, "%s - %d", textofs, frame);
					else allegro_gl_printf(allegro_fnt[1], i*3-20, 8.7-(3.5-(float)frame/10), k*3-3.5, 0, "%s - %d", textofs, frame);
					glDisable (GL_BLEND);
					
				}
				else if(casilla==101) //trampolin direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[1]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-1);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[21]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),    0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3),    1, (k*3)-3);
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),    0, (k*3)-1);
					glEnd();
				}
				else if(casilla==102) //trampolin direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[1]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-2);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-2);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[21]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3));
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-2);
						glTexCoord2f (1, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3),    1, (k*3));
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-2);
					glEnd();
				}
				else if(casilla==103) //trampolin direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[2]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[21]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3));
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+1,  0, (k*3)-3);
					glEnd();
				}
				else if(casilla==104) //trampolin direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[2]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[21]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),  1, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3),  0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3),  1, (k*3));
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+2, 0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),   0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3),   1, (k*3)-3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3),   1, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3),   0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2, 0, (k*3));
					glEnd();
				}
				else if(casilla==105) //muro x
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),   1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3),   0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3, 0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3, 1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+3, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3, 0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3),   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3),   1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),   1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3, 1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3),   1.5, (k*3)-2.5);
					glEnd();
				}
				else if(casilla==106) //muro z
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5, 0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5, 0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5, 1.5, (k*3));
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-0);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5, 0, (k*3)-0);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5, 0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-3);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5, 1.5, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5, 1.5, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-3);
					glEnd();
				}
				else if(casilla==107) //muro esquina1
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,    1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,      0, (k*3)-3);
						glTexCoord2f (0.17, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (0.17, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,    1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,      0, (k*3)-0.5);
						glTexCoord2f (0.83, 0); glVertex3f((i*3)+2.5,   0, (k*3)-3);
						glTexCoord2f (0.83, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-3);
					
						glTexCoord2f (0, 0.83); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						glTexCoord2f (1, 0.83); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,    1.5, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,    1.5, (k*3)-3);

						glTexCoord2f (0, 1); glVertex3f((i*3),        1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3),          0, (k*3)-0.5);
						glTexCoord2f (0.83, 0); glVertex3f((i*3)+2.5,   0, (k*3)-0.5);
						glTexCoord2f (0.83, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-0.5);
					
						glTexCoord2f (0.83, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0.83, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3),          0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3),        1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),        1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,    1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,    1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3),        1.5, (k*3)-2.5);
					glEnd();
				}
				else if(casilla==108) //muro esquina2
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,       0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,     1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,     1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,       0, (k*3)-2.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+2.5,  0, (k*3)-2.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+2.5,1.5,(k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,   1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,     1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,     1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-0.5);
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,   1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,     0, (k*3)-2.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+2.5,  0, (k*3)-3);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+2.5,1.5, (k*3)-3);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,   1.5, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,   1.5, (k*3)-2.5);
						glTexCoord2f (1, 0.18); glVertex3f((i*3)+2.5,1.5, (k*3)-3);
						glTexCoord2f (0, 0.18); glVertex3f((i*3)+0.5,1.5, (k*3)-3);
					glEnd();
				}
				else if(casilla==109) //muro esquina3
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,    0, (k*3)-0.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+3,   0, (k*3)-0.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+3, 1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,   1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5, 1.5,(k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,   1.5, (k*3)-0.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+3,  1.5, (k*3)-0.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+3,  1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,   1.5, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,   0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5, 1.5, (k*3));
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,   1.5, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,     0, (k*3));
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+2.5,  0, (k*3)-0.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+2.5,1.5, (k*3)-0.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,  1.5, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,  1.5, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-2.5);
					glEnd();
				}
				else if(casilla==110) //muro esquina4
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),        1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3),          0, (k*3)-0.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+0.5,   0, (k*3)-0.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,    0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3),        0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3),      1.5,(k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),        1.5, (k*3)-0.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+0.5, 1.5, (k*3)-0.5);
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3),        1.5, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,    1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,      0, (k*3)-0.5);
						glTexCoord2f (0.18, 0); glVertex3f((i*3)+0.5,   0, (k*3));
						glTexCoord2f (0.18, 1); glVertex3f((i*3)+0.5, 1.5, (k*3));
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,    1.5, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,      0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,    1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,    1.5, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,    1.5, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,    1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,    1.5, (k*3)-2.5);
					glEnd();
				}
				else if(casilla==111) //tapn muro z abajo
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]); 
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,    0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,    0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-0.5);
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,    0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,    0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-3);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,  1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,  1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,    0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,    0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5,  1.5, (k*3)-0.5);
					glEnd();
				}
				else if(casilla==112) //tapon muro z arriba
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,   0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5, 1.5, (k*3));
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5, 1.5, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,   0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5, 1.5, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5, 1.5, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5, 1.5, (k*3)-2.5);
					glEnd();
				}
				else if(casilla==113) //tapon muro x izquierda
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,    0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,      0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,    1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+3,    1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,      0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,    0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,  1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,   1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,     1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,     1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   1.5, (k*3)-0.5);
					glEnd();
				}
				else if(casilla==114) //tapon muro x derecha
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),     1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3),       0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,   0, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-0.5);
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3),       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3),     1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),     1.5, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5, 1.5, (k*3)-0.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3),     1.5, (k*3)-2.5);
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-0.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+2.5,   0, (k*3)-0.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2.5, 1.5, (k*3)-2.5);
					
					glEnd();
				}
				else if(casilla==115) //tapon muro cuadrao suelto
				{
					glBindTexture (GL_TEXTURE_2D, textura[22]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3),     1.5, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3),       0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,   0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3, 1.5, (k*3));
				
						glTexCoord2f (0, 1); glVertex3f((i*3)+3, 1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,   0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),       0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3),     1.5, (k*3)-3);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),     1.5, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3, 1.5, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3, 1.5, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),     1.5, (k*3)-3);
					
						glTexCoord2f (0, 1); glVertex3f((i*3)+3, 1.5, (k*3));
						glTexCoord2f (0, 0); glVertex3f((i*3)+3,   0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,   0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3, 1.5, (k*3)-3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3),   1.5, (k*3)-3);
						glTexCoord2f (0, 0); glVertex3f((i*3),     0, (k*3)-3);
						glTexCoord2f (1, 0); glVertex3f((i*3),     0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3),   1.5, (k*3));
					
					glEnd();
				}
				else if(casilla==116) //rampa hierba direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),    0, (k*3)-1);
					glEnd();
				}
				else if(casilla==117) //rampa hierba direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-2);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-2);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==118) //rampa hierba direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==119) //rampa hierba direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
					glEnd();
				}
				else if(casilla==120) //rampa asfalto direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[1]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),    0, (k*3)-1);
					glEnd();
				}
				else if(casilla==121) //rampa asfalto direccion z
				{
					glBindTexture (GL_TEXTURE_2D, textura[1]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-2);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-2);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==122) //rampa asfalto direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[2]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==123) //rampa asfalto direccion x
				{
					glBindTexture (GL_TEXTURE_2D, textura[2]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
						
						glTexCoord2f (0, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
					glEnd();
				}
				else if(casilla==124) // casa 1 ocupa 4 casillas 6 de alto (puerta izquierda)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[24]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+2.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[26]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+2.5);
					
					glEnd();
				}
				else if(casilla==125) //muro invisible que colisiona 6 de alto para casa(suelo de hierba)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
				}
				else if(casilla==126) // casa 1 ocupa 4 casillas 6 de alto (puerta abajo)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[24]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+2.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[26]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+2.5);
					
					glEnd();
				}
				else if(casilla==127) // casa 1 ocupa 4 casillas 6 de alto (puerta arriba)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+2.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[26]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[24]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+2.5);
					
					glEnd();
				}
				else if(casilla==128) // casa 1 ocupa 4 casillas 6 de alto (puerta derecha)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[26]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+2.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+2.5);
					
					glEnd();
				}			
				else if(casilla==129) //pino (dibuja solo la hierba, luego pino trans)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-3);
					glEnd();
				}
				else if(casilla==130) // casa 2  ocupa 4 casillas 12 de alto (puerta derecha)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);  //suelo
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[26]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+2.5);
					glEnd();
					
					glBindTexture (GL_TEXTURE_2D, textura[28]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     12, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       6, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 12, (k*3)+2.5);

						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 12, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   6, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       6, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     12, (k*3)-2.5);

						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 12, (k*3)+2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   6, (k*3)+2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   6, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 12, (k*3)-2.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   12, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     6, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   12, (k*3)+2.5);
					glEnd();
					
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     12, (k*3)+2.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       12, (k*3)+2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       12, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     12, (k*3)-2.5);
					glEnd();
				}
				
				else if(casilla==131) //muro invisible que colisiona 6 de alto para casa(suelo de hierba)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
				}
				
				else if(casilla==132) // bungalow 1 ocupa 4X8 casillas 6 de alto (puerta izquierda)
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),      0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),      0, (k*3)-3);
					glEnd();
					glBindTexture (GL_TEXTURE_2D, textura[24]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+8.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,       0, (k*3)+8.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+8.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+8.5);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[23]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+3); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)-2.5);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
						
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     6, (k*3)+8.5); //techo
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,       6, (k*3)+8.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5,       6, (k*3)+3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,     6, (k*3)+3);
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[25]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)+8.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)+8.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+5.5,   0, (k*3)+3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+5.5, 6, (k*3)+3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+5.5, 6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+5.5,   0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,       0, (k*3)-2.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,     6, (k*3)-2.5);
						
					glEnd();		
					glBindTexture (GL_TEXTURE_2D, textura[27]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)-2.5);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)-2.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+3);
						
						glTexCoord2f (0, 1); glVertex3f((i*3)+0.5,   6, (k*3)+3);
						glTexCoord2f (0, 0); glVertex3f((i*3)+0.5,     0, (k*3)+3);
						glTexCoord2f (1, 0); glVertex3f((i*3)+0.5,     0, (k*3)+8.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+0.5,   6, (k*3)+8.5);
					glEnd();
				}
				else if(casilla==133) //rampa hierba direccion esquina ar-i
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0);   glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						glTexCoord2f (0, 1);   glVertex3f((i*3),    0, (k*3)-3);
						
						glTexCoord2f (0, 0);   glVertex3f((i*3)+1,  0, (k*3)-2);
						glTexCoord2f (1, 0);   glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 0.3); glVertex3f((i*3)+1,  0, (k*3)-3);
					glEnd();
					glBegin (GL_TRIANGLES);	
						//glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  0, (k*3)-2);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,    0, (k*3)-2);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						//glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,  0, (k*3)-2);
					glEnd();
				}
				else if(casilla==134) //rampa hierba direccion esquina ar-d
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0);   glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1);   glVertex3f((i*3)+2,  0, (k*3)-3);
						
						glTexCoord2f (0, 0);   glVertex3f((i*3),  0, (k*3)-2);
						glTexCoord2f (1, 0);   glVertex3f((i*3)+2,  0, (k*3)-2);
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+2,  0, (k*3)-3);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),  0, (k*3)-3);
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						//glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-2);
						glTexCoord2f (0, 1); glVertex3f((i*3),    0, (k*3)-2);
					
						glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-2);
						//glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
					glEnd();
				}
				else if(casilla==135) //rampa hierba direccion esquina ab-i
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0);   glVertex3f((i*3),    0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
						glTexCoord2f (0, 1);   glVertex3f((i*3),    0, (k*3)-3);
						
						glTexCoord2f (0, 0);   glVertex3f((i*3)+1,  0, (k*3));
						glTexCoord2f (1, 0);   glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (0, 0.3); glVertex3f((i*3)+1,  0, (k*3)-1);
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,    0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-1);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						//glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
					
						glTexCoord2f (0, 0); glVertex3f((i*3)+1,  0, (k*3)-1);
						//glTexCoord2f (1, 0); glVertex3f((i*3)+3,  1, (k*3));
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1,  0, (k*3)-3);
					glEnd();
				}
				else if(casilla==136) //rampa hierba direccion esquina ab-d
				{
					glBindTexture (GL_TEXTURE_2D, textura[0]);
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0);   glVertex3f((i*3)+2,    0, (k*3));
						glTexCoord2f (0.3, 0); glVertex3f((i*3)+3,  0, (k*3));
						glTexCoord2f (0.3, 1); glVertex3f((i*3)+3,  0, (k*3)-3);
						glTexCoord2f (0, 1);   glVertex3f((i*3)+2,    0, (k*3)-3);
						
						glTexCoord2f (0, 0);   glVertex3f((i*3),  0, (k*3));
						glTexCoord2f (1, 0);   glVertex3f((i*3)+2,  0, (k*3));
						glTexCoord2f (1, 0.3); glVertex3f((i*3)+2,  0, (k*3)-1);
						glTexCoord2f (0, 0.3); glVertex3f((i*3),  0, (k*3)-1);
					glEnd();
					glBegin (GL_TRIANGLES);	
						glTexCoord2f (0, 0); glVertex3f((i*3),    0, (k*3)-1);
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3)-1);
						//glTexCoord2f (1, 1); glVertex3f((i*3)+3,  1, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
					
						//glTexCoord2f (0, 0); glVertex3f((i*3),    1, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+2,  0, (k*3)-1);
						glTexCoord2f (1, 1); glVertex3f((i*3)+2,  0, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3),    1, (k*3)-3);
					glEnd();
				}
				
				glTranslatef (0, -desfy, 0);
			}
			
		}
	}

	glDisable (GL_TEXTURE_2D);
	
	glColor3f(0.0,0.7,0.0);
	
	for(i=0;i<40;i+=2)
	{
		glBegin (GL_LINE_LOOP);	
			glVertex3f(0,    1+i,  -3);
			glVertex3f(0,    1+i, 147);
			glVertex3f(150,  1+i, 147);
			glVertex3f(150,  1+i,  -3);
		glEnd();
	}
	glEnable (GL_TEXTURE_2D);
	
	
	
	for(i=0;i<tamano_mapa;i++) //ahora para los transparentes
	{
		for(k=0;k<tamano_mapa;k++)
		{
			//if(abs(i*3+camara.dist_x)<40)
			//if(abs(k*3+camara.dist_z)<40)
			if((camara.yangle>-10 && camara.yangle<=180 && i*3+camara.dist_x<35 && i*3+camara.dist_x>-25)
				|| (camara.yangle>180 && camara.yangle<400 && i*3+camara.dist_x>-35 && i*3+camara.dist_x<25)) 
			if(( ((camara.yangle>270 || camara.yangle<=90)) && k*3+camara.dist_z>-35 && k*3+camara.dist_z<25)
				|| (camara.yangle>90 && camara.yangle<=270 && k*3+camara.dist_z<35 && k*3+camara.dist_z>-25)) 
			{
				
				glTranslatef (0, 0, 0);
				desfy=0;
				casilla=mapa[k][i];
				if(casilla>=300 && casilla<400)
				{
					desfy=1;
					glTranslatef (0, desfy, 0);
					casilla-=200;
				}
				if(casilla>=400 && casilla<600)
				{
					desfy=2;
					glTranslatef (0, desfy, 0);
					casilla-=400;
				}
				if(casilla>=600 && casilla<800)
				{
					desfy=3;
					glTranslatef (0, desfy, 0);
					casilla-=600;
				}
				if(casilla>=800 && casilla<1000)
				{
					desfy=4;
					glTranslatef (0, desfy, 0);
					casilla-=800;
				}
				if(casilla==129) //Pino
				{
					glDepthMask(GL_FALSE);	
					glEnable(GL_BLEND);
					glDisable (GL_CULL_FACE);	
					glBlendFunc(GL_DST_COLOR, GL_ZERO);
					
					glBindTexture (GL_TEXTURE_2D, textura[34]); //arboles mascara
					glBegin (GL_QUADS);	
						glTexCoord2f (0, 0); glVertex3f((i*3),  0, (k*3)-1.5);
						glTexCoord2f (1, 0); glVertex3f((i*3)+3,  0, (k*3)-1.5);
						glTexCoord2f (1, 1); glVertex3f((i*3)+3,  5, (k*3)-1.5);
						glTexCoord2f (0, 1); glVertex3f((i*3),  5, (k*3)-1.5);
						
						glTexCoord2f (0, 0); glVertex3f((i*3)+1.5,  0, (k*3));
						glTexCoord2f (1, 0); glVertex3f((i*3)+1.5,  0, (k*3)-3);
						glTexCoord2f (1, 1); glVertex3f((i*3)+1.5,  5, (k*3)-3);
						glTexCoord2f (0, 1); glVertex3f((i*3)+1.5,  5, (k*3));	
					glEnd();
					
					glDisable(GL_BLEND);
					glEnable (GL_CULL_FACE);
					glDepthMask(GL_TRUE);		
				}
				
				glTranslatef (0, -desfy, 0);
			}
		}
	}
	

	
	marcadores();

	
	glFlush();

	allegro_gl_flip();
	allegro_gl_end();

}

void marcadores(void)
{

	glMatrixMode(GL_PROJECTION);

	glLoadIdentity(); 
	
	glScalef(0.025,0.025,1);

	//glDisable (GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glDepthMask(GL_FALSE);	
	
	
/*	glColor4f(0.5,0.5,1,1);
	glBegin (GL_QUADS);	
		glVertex3f(25, 33, 0.5);
		glVertex3f(25+vel_front*25, 33, 0.5);
		glVertex3f(25+vel_front*25, 37, 0.5);
		glVertex3f(25, 37, 0.5);
	glEnd();

	glEnable (GL_TEXTURE_2D);
	glBlendFunc(GL_ZERO,GL_ONE_MINUS_SRC_COLOR);
	allegro_gl_printf(allegro_fnt[1], -37, 38, 0, makeacol(255,255,255,255), "Posicion= %d,%f,%d",(int)-camara.dist_x,camara.dist_y,(int)-camara.dist_z);
	allegro_gl_printf(allegro_fnt[1], -37, 34, 0, makeacol(255,255,255,255), "Casilla= %d",casilla_actual);

	glBlendFunc(GL_ONE,GL_ONE);
	allegro_gl_printf(allegro_fnt[3], -37, 38, 0, makeacol(255,255,255,255), "Posicion= %d,%f,%d",(int)-camara.dist_x,camara.dist_y,(int)-camara.dist_z);
	allegro_gl_printf(allegro_fnt[3], -37, 34, 0, makeacol(255,255,255,255), "Casilla= %d",casilla_actual);
*/


	allegro_gl_set_projection();
		
	glEnable (GL_TEXTURE_2D);
	
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	glBindTexture (GL_TEXTURE_2D, textura1[0]);
	glBegin (GL_QUADS);	
		glTexCoord2f (0, 0); glVertex3f(0,   480,0);
		glTexCoord2f (1, 0); glVertex3f(640, 480,0);
		glTexCoord2f (1, 1); glVertex3f(640, 324,0);
		glTexCoord2f (0, 1); glVertex3f(0,   324,0);
	glEnd();
	
	glBlendFunc(GL_ONE,GL_ONE);
	glBindTexture (GL_TEXTURE_2D, textura1[1]);
	glBegin (GL_QUADS);	
		glTexCoord2f (0, 0); glVertex3f(0,   480,0);
		glTexCoord2f (1, 0); glVertex3f(640, 480,0);
		glTexCoord2f (1, 1); glVertex3f(640, 324,0);
		glTexCoord2f (0, 1); glVertex3f(0,   324,0);
	glEnd();

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	triangle(screen,584-sin(1.87-vel_vert*9)*27,420-cos(1.87-vel_vert*9)*27,
					584-sin(    -vel_vert*9)*3 ,420-cos(    -vel_vert*9)*3 ,
					584-sin(3.44-vel_vert*9)*3 ,420-cos(3.44-vel_vert*9)*3 , 
					makecol(200, 0, 0) );

	glEnable (GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	allegro_gl_unset_projection();
	
	
	glBlendFunc(GL_ONE,GL_ONE);

	allegro_gl_printf(allegro_fnt[3], -37,  35, 0, 0, "RPM =%f", vel_front);
	allegro_gl_printf(allegro_fnt[3], -37,  30, 0, 0, "Vel.m=%f", vel_vert);

	allegro_gl_printf(allegro_fnt[2], -20, -21, 0, 0, "x=%f",camara.dist_x);
	allegro_gl_printf(allegro_fnt[2], -20, -24, 0, 0, "z=%f",camara.dist_z);
	allegro_gl_printf(allegro_fnt[2], -20, -27, 0, 0, "y=%f",camara.dist_y);
	
	allegro_gl_printf(allegro_fnt[2], 0, -24, 0, 0, "yangle=%f",camara.yangle);

	allegro_gl_printf(allegro_fnt[1], -27, -36, 0, 0, "Fixi Studios  -  Nitrito v0.2   LCTRL-skid SPACE-fly");


	glDisable(GL_BLEND);
	glDepthMask(GL_TRUE);	
}
